package com.nisum.employeeservice.service;

import com.nisum.employeeservice.model.Employee;
import com.nisum.employeeservice.repository.EmployeeRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class EmployeeService {

	@Autowired EmployeeRepository employeeRepository;


	public List<Employee> findAllEmployees() {
		/*some business*/
		return employeeRepository.findAll();
	}


	public Employee addEmployee(Employee employee) {
		return employeeRepository.save(employee);
	}

	public void deleteEmployee(Employee employee) {
		employeeRepository.delete(employee);
	}

	public Employee findEmployeeById(long id) {
		Optional<Employee> found = employeeRepository.findById(id);
		if (found.isPresent()) {
			return found.get();
		}
		return null;
	}

	public void deleteEmployeeById(Long id) {
		employeeRepository.deleteById(id);
	}
}
